diff --git a/modules/features/chatbot/mainChatbot.py b/modules/features/chatbot/mainChatbot.py
index 1428ef41..acb9a0e6 100644
--- a/modules/features/chatbot/mainChatbot.py
+++ b/modules/features/chatbot/mainChatbot.py
@@ -1007,22 +689,26 @@ WICHTIG:
             }
         )
         
-        # Update workflow status to completed
-        interfaceDbChat.updateWorkflow(workflowId, {
-            "status": "completed",
-            "lastActivity": getUtcTimestamp()
-        })
+        # Update workflow status to completed (only if not stopped)
+        if not await _check_workflow_stopped(interfaceDbChat, workflowId):
+            interfaceDbChat.updateWorkflow(workflowId, {
+                "status": "completed",
+                "lastActivity": getUtcTimestamp()
+            })
+        else:
+            logger.info(f"Workflow {workflowId} was stopped, not updating status to completed")
         
-        logger.info(f"Chatbot processing completed for workflow {workflowId}")
+        logger.info(f"Chatbot processing completed for workflow {workflowId}, generated {len(queries)} queries and final answer")
         
-        # Emit completion event
-        await event_manager.emit_event(
-            workflowId,
-            "complete",
-            "Chatbot-Verarbeitung abgeschlossen",
-            "complete",
-            {"workflowId": workflowId}
-        )
+        # Emit completion event only if workflow wasn't stopped
+        if not await _check_workflow_stopped(interfaceDbChat, workflowId):
+            await event_manager.emit_event(
+                workflowId,
+                "complete",
+                "Chatbot-Verarbeitung abgeschlossen",
+                "complete",
+                {"workflowId": workflowId}
+            )
         
         # Schedule cleanup
         await event_manager.cleanup(workflowId)
@@ -1030,11 +716,21 @@ WICHTIG:
     except Exception as e:
         logger.error(f"Error processing chatbot message: {str(e)}", exc_info=True)
         
+        # Check if workflow was stopped - if so, don't store error message
+        if await _check_workflow_stopped(interfaceDbChat, workflowId):
+            logger.info(f"Workflow {workflowId} was stopped, not storing error message")
+            return
+        
         # Store error message
         try:
             # Reload workflow to get current message count
             workflow = interfaceDbChat.getWorkflow(workflowId)
             
+            # Double-check workflow wasn't stopped while we were reloading
+            if workflow and workflow.status == "stopped":
+                logger.info(f"Workflow {workflowId} was stopped, not storing error message")
+                return
+            
             errorMessageData = {
                 "id": f"msg_{uuid.uuid4()}",
                 "workflowId": workflowId,
@@ -1065,14 +761,16 @@ WICHTIG:
                 }
             )
             
-            # Update workflow status to error
-            interfaceDbChat.updateWorkflow(workflowId, {
-                "status": "error",
-                "lastActivity": getUtcTimestamp()
-            })
+            # Update workflow status to error (only if not stopped)
+            if not await _check_workflow_stopped(interfaceDbChat, workflowId):
+                interfaceDbChat.updateWorkflow(workflowId, {
+                    "status": "error",
+                    "lastActivity": getUtcTimestamp()
+                })
+            else:
+                logger.info(f"Workflow {workflowId} was stopped, not updating status to error")
             
             # Schedule cleanup
             await event_manager.cleanup(workflowId)
         except Exception as storeError:
             logger.error(f"Error storing error message: {storeError}")
-
diff --git a/modules/routes/routeChatbot.py b/modules/routes/routeChatbot.py
index 0c3e2314..25e24164 100644
--- a/modules/routes/routeChatbot.py
+++ b/modules/routes/routeChatbot.py
@@ -85,16 +85,51 @@ async def stream_chatbot_start(
                 # Get interface for status checks and chat data
                 interfaceDbChat = getServiceChat(currentUser)
                 
+                # Get current workflow to check if resuming and get current round
+                current_workflow = interfaceDbChat.getWorkflow(workflow.id)
+                current_round = current_workflow.currentRound if current_workflow else None
+                is_resuming = final_workflow_id is not None and current_round and current_round > 1
+                
                 # Send initial chat data (exact format as chatData endpoint)
                 try:
                     chatData = interfaceDbChat.getUnifiedChatData(workflow.id, None)
                     if chatData.get("items"):
+                        # Filter items by round number if resuming
+                        filtered_items = []
                         for item in chatData["items"]:
+                            if is_resuming and current_round:
+                                # Get round number from item
+                                item_round = None
+                                item_data = item.get("item")
+                                if item_data:
+                                    # Handle both dict and object access
+                                    if isinstance(item_data, dict):
+                                        item_round = item_data.get("roundNumber")
+                                    elif hasattr(item_data, "roundNumber"):
+                                        item_round = item_data.roundNumber
+                                
+                                # When resuming, only include items from current round onwards
+                                # Exclude items without roundNumber (they're from old rounds before roundNumber was added)
+                                # Exclude items with roundNumber < current_round (from previous rounds)
+                                if item_round is None or item_round < current_round:
+                                    continue  # Skip items from previous rounds or without round info
+                            
+                            filtered_items.append(item)
+                        
+                        # Emit filtered items
+                        for item in filtered_items:
+                            # Convert Pydantic models to dicts for JSON serialization
+                            serializable_item = {
+                                "type": item.get("type"),
+                                "createdAt": item.get("createdAt"),
+                                "item": item.get("item").dict() if hasattr(item.get("item"), "dict") else item.get("item")
+                            }
                             # Emit item directly in exact chatData format: {type, createdAt, item}
-                            yield f"data: {json.dumps(item)}\n\n"
+                            yield f"data: {json.dumps(serializable_item)}\n\n"
+                        
                         # Set initial timestamp for incremental fetching
-                        if chatData["items"]:
-                            timestamps = [parseTimestamp(item.get("createdAt"), default=0) for item in chatData["items"]]
+                        if filtered_items:
+                            timestamps = [parseTimestamp(item.get("createdAt"), default=0) for item in filtered_items]
                             last_chatdata_timestamp = max(timestamps) if timestamps else None
                         else:
                             last_chatdata_timestamp = None
@@ -152,9 +187,37 @@ async def stream_chatbot_start(
                         try:
                             chatData = interfaceDbChat.getUnifiedChatData(workflow.id, last_chatdata_timestamp)
                             if chatData.get("items"):
-                                # Emit items directly in exact chatData format: {type, createdAt, item}
+                                # Filter items by round number if resuming
+                                filtered_items = []
                                 for item in chatData["items"]:
-                                    yield f"data: {json.dumps(item)}\n\n"
+                                    if is_resuming and current_round:
+                                        # Get round number from item
+                                        item_round = None
+                                        item_data = item.get("item")
+                                        if item_data:
+                                            # Handle both dict and object access
+                                            if isinstance(item_data, dict):
+                                                item_round = item_data.get("roundNumber")
+                                            elif hasattr(item_data, "roundNumber"):
+                                                item_round = item_data.roundNumber
+                                        
+                                        # When resuming, only include items from current round onwards
+                                        # Exclude items without roundNumber (they're from old rounds before roundNumber was added)
+                                        # Exclude items with roundNumber < current_round (from previous rounds)
+                                        if item_round is None or item_round < current_round:
+                                            continue  # Skip items from previous rounds or without round info
+                                    
+                                    filtered_items.append(item)
+                                
+                                # Emit filtered items directly in exact chatData format: {type, createdAt, item}
+                                for item in filtered_items:
+                                    # Convert Pydantic models to dicts for JSON serialization
+                                    serializable_item = {
+                                        "type": item.get("type"),
+                                        "createdAt": item.get("createdAt"),
+                                        "item": item.get("item").dict() if hasattr(item.get("item"), "dict") else item.get("item")
+                                    }
+                                    yield f"data: {json.dumps(serializable_item)}\n\n"
                                 # Update timestamp to only get new items next time
                                 if chatData["items"]:
                                     # Parse timestamps and get the maximum
@@ -177,6 +240,12 @@ async def stream_chatbot_start(
                         if event.get("type") == "chatdata" and event.get("data"):
                             # Emit item directly in exact chatData format: {type, createdAt, item}
                             chatdata_item = event.get("data")
+                            # Ensure item field is serializable (convert Pydantic models to dicts)
+                            if isinstance(chatdata_item, dict) and "item" in chatdata_item:
+                                item_obj = chatdata_item.get("item")
+                                if hasattr(item_obj, "dict"):
+                                    chatdata_item = chatdata_item.copy()
+                                    chatdata_item["item"] = item_obj.dict()
                             yield f"data: {json.dumps(chatdata_item)}\n\n"
                             # Update timestamp for incremental fetching
                             if chatdata_item.get("createdAt"):

